Subject: RE: [Uri-review] SMB URL v05.

From: "McDonald, Ira" <[email-masked]>
Date: Mon, 11 Aug 2003 12:30:54 -0700

Hi Martin,

I'm concerned.  SLP "service:" URL (RFC 2609) has a basic
dependence on the differentiation that "scheme://..." is
a DNS-based URL and "scheme:/ipx/..." is a NetWare URL
(Appletalk is also supported).

There is a heck of a lot of deployed SLP software that uses
non-DNS URLs regularly.

Cheers,
- Ira McDonald
  High North Inc

[excerpts from the ABNF in RFC 2609]

service: URL    =   "service:" service-type ":" sap
service-type    =   abstract-type ":" url-scheme / concrete-type
abstract-type   =   type-name [ "." naming-auth ]
concrete-type   =   protocol [ "." naming-auth ]

sap             =   site [url-part]
site            =   ipsite / atsite / ipxsite
ipsite          =   "//" [ [ user "@" ] hostport ]
ipxsite         =   "/ipx/" ipx-net ":" ipx-node ":" ipx-socket
atsite          =   "/at/" at-object ":" at-type "" at-zone

-----Original Message-----
From: Christopher R. Hertel [mailto:[email-masked]]
Sent: Monday, August 11, 2003 2:44 PM
To: Martin Duerst
Cc: Christopher R. Hertel; [email-masked]
Subject: Re: [Uri-review] SMB URL v05.

On Mon, Aug 11, 2003 at 10:30:15AM -0400, Martin Duerst wrote:
> Hello Christopher,
> 
> Have you checked your syntax for compatibility with the RFC2396bis
> update (draft-fielding-uri-rfc2396bis-03)?
> 
> In particular, it looks like you are allowing non-DNS stuff in
> the authority (hostname) part. RDF2396bis does no longer allow
> this.

There's no option on that.  SMB can and does use RFC1001/1002 NBT naming 
for service access.  Any URL for SMB must support this.  It's just part of 
the protocol.

Chris -)-----

-- 
"Implementing CIFS - the Common Internet FileSystem" ISBN: 013047116X
Samba Team -- http://www.samba.org/     -)-----   Christopher R. Hertel
jCIFS Team -- http://jcifs.samba.org/   -)-----   ubiqx development, uninq.
ubiqx Team -- http://www.ubiqx.org/     -)-----   [email-masked]
OnLineBook -- http://ubiqx.org/cifs/    -)-----   [email-masked]

_______________________________________________
Uri-review mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/uri-review

_______________________________________________
Uri-review mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/uri-review

---

From: Martin Duerst <[email-masked]>
Date: Mon, 11 Aug 2003 16:22:41 -0400

Hello Ira,

[I have copied the uri list.]
Is it possible to construct service URIs from arbitrary other
URIs, or are there some restrictions?

Please note that RFC 2396 does not restrict the syntax after
// to be [ [ userinfo "@" ] hostport ]. In particular we have
(from http://www.ietf.org/rfc/rfc2396.txt, App A. Collected BNF for URI):

net_path      = "//" authority [ abs_path ]
authority     = server | reg_name
reg_name      = 1*( unreserved | escaped | "$" | "," |
                           ";" | ":" | "@" | "&" | "=" | "+" )
server        = [ [ userinfo "@" ] hostport ]

This leaves open the "regname" part, which is arbitrary.
This means that if the 'service:' uri allows to just plug
in arbitrary URIs, it would be against the current RFC 2396
syntax. However, it would be okay with the new, proposed
RFC 2396bis syntax.

Also, are you saying that the /ipx/ and /at/ conventions
should be general conventions for URIs? Or are they just
conventions within the 'service:' URI Scheme?

Please note that the change from RFC 2396 to RFC 2396bis
does not prohibit the use of  things such as NetWare or
Appletalk as long as they don't appear after //, which
seems to be okay for the 'service:' URI, but not for
SMB.

Regards,    Martin.

---

From: "McDonald, Ira" <[email-masked]>
Date: Tue, 12 Aug 2003 09:32:59 -0700

Hi Martin,

Thanks for your clarifications.

Yes, I suggest the '/ipx/' and '/at/' forms in RFC 2609
URIs for NetWare/IPX and Appletalk should be included
in RFC2396bis.  URIs are much more useful if they
can extend beyond DNS-based naming/addressing.

Service URIs are _supposed_ to be constructed based on
existing "concrete" (IANA-registered) URI schemes.

Service URIs that are self-descriptive use the SLPv2 
format of "service:abstract-type:concrete-type:...",
where "abstract-type" is an IANA-registered (or private)
abstract service type (for example "printer"), as 
published in the directory:

    ftp://ftp.iana.org/assignments/svrloc-templates/

For example, a single SLP (or equivalent LDAP) service
advertisement that uses abstract "service:printer:..."
often includes more six or more legacy print protocols
in the attribute "printer-xri-supported" (which supports
authentication and security elements separate from the
URI themselves).

Cheers,
- Ira McDonald, co-editor of SLP and LDAP Printer schemes
  High North Inc

-----Original Message-----
From: Martin Duerst [mailto:[email-masked]]
Sent: Monday, August 11, 2003 4:23 PM
To: McDonald, Ira; 'Christopher R. Hertel'
Cc: [email-masked]; [email-masked]
Subject: RE: [Uri-review] SMB URL v05.

Hello Ira,

Regards,    Martin.